import { system } from "@minecraft/server";
import {
  ActionFormData,
  MessageFormData,
  ModalFormData,
} from "@minecraft/server-ui";

export async function ForceShow(form, player, timeout = 10) {
  const end = system.currentTick + (timeout === -1 ? 9999 * 20 : timeout * 20);
  while (system.currentTick <= end) {
    const response = await form.show(player);
    if (response.cancelationReason !== "UserBusy") {
      return response;
    }
  }
  throw new Error(`Timed out after ${timeout} ticks`);
}
