import { world } from "@minecraft/server";
import { SIGNAL } from "./dz-signal";
export class SBDB {
  oB;
  data;
  constructor(nama = "dz:setting") {
    this.oB = world.scoreboard.getObjective(nama);
    if (!this.oB) this.oB = world.scoreboard.addObjective(nama, nama);
    this.reload();
  }
  reload() {
    this.data = {};
    this.oB.getParticipants().forEach((o) => {
      const a = o.displayName.match(/^([^:]*):(.*)/);
      this.data[a[1]] = a[2];
    });
  }
  set(id, data) {
    const a = this.data[id];
    if (a) this.oB.removeParticipant(`${id}:${a}`);
    this.oB.addScore(`${id}:${data}`, 0);
    this.reload();
    SIGNAL.emit("setting", "reload", "");
  }
  delete(id) {
    const a = this.data[id];
    if (a) this.oB.removeParticipant(`${id}:${a}`);
    this.reload();
    SIGNAL.emit("setting", "reload", "");
  }
  get(id) {
    return this.data[id] || "";
  }
  has(id) {
    return Boolean(this.data[id]);
  }
}
