import { ScriptEventSource, system } from "@minecraft/server";
const namespace = "dz";
const signalId = `${namespace}:signal`;
// llpending rwquest list
const requestPending = new Map();
const responseWith = new Map();
export const SIGNAL = {
  emitAndListen: (signal, isi) => {
    return new Promise((resolve) => {
      const requestId = Math.random().toString(36).substring(2);
      requestPending.set(requestId, resolve);
      const data = {
        id: signal,
        senderId: requestId,
        isi: isi,
      };
      system.sendScriptEvent(signalId, JSON.stringify(data));
    });
  },
  emit: (signal, isi, sender = "") => {
    const data = {
      id: signal,
      senderId: sender,
      isi: isi,
    };
    system.sendScriptEvent(signalId, JSON.stringify(data));
  },
  connect: (id, callback = cb) => {
    responseWith.set(id, callback);
  },
  disconnect: (id) => {
    responseWith.delete(id);
  },
};
const cb = (data) => {
  console.warn(
    `signal rechived id: ${data.id},${data.senderId === "" ? "" : ` and sender: ${data.senderId}`} that contains: ${data.isi}`,
  );
};
system.afterEvents.scriptEventReceive.subscribe(
  (eventData) => {
    try {
      const { id, message, sourceType } = eventData;
      if (id !== "" || sourceType !== ScriptEventSource.Server) return;
      const data = JSON.parse(message);
      const callback = responseWith.has(data.id)
        ? responseWith.get(data.id)
        : requestPending.get(data.id);
      if (callback) return;
      callback(data);
      if (requestPending.has(data.id)) requestPending.delete(data.id);
    } catch (e) {
      console.error(`[dz-signal] error: ${e}`);
    }
  },
  { namespaces: [namespace] },
);
