import { system } from "@minecraft/server";
export function waitTimer(player, detik, funct) {
  let lastPos = player.location;
  if (detik < 1) return funct();
  let ticking = detik * 20;
  player.sendMessage("<tp> please wait and don\' move");
  const id = system.runInterval(() => {
    const currentPos = player.location;
    if (
      !player.isOnGround ||
      currentPos.x !== lastPos.x ||
      currentPos.y !== lastPos.y ||
      currentPos.z !== lastPos.z
    ) {
      system.clearRun(id);
      player.onScreenDisplay.setTitle("§4Canceled", {
        stayDuration: 8,
        fadeInDuration: 1,
        fadeOutDuration: 1,
      });
      return;
    }
    if (ticking % 20 === 0) {
      player.onScreenDisplay.setTitle("§2" + ticking / 20, {
        stayDuration: 5,
        fadeInDuration: 1,
        fadeOutDuration: 3,
      });
      player.playSound("note.pling", {
        pitch: ticking > 10 ? 1.7 : 1.9,
        volume: 0.62,
      });
    }
    if (ticking <= 0) {
      system.clearRun(id);
      system.run(funct);
    }
    ticking--;
  });
}
